import { XPromiseError } from './error';
import { XPromiseExecutor } from './rawInfo';
import { XPromiseErrorCodeEnum } from './utils';

export { XPromiseError, XPromiseErrorCodeEnum };
/** promise拓展 */
export declare class XPromise<T> implements Promise<T> {
    #private;
    /** promise共享 */
    static useSharing: <P extends Promise<any>>(createPromise: () => P) => {
        applyPromise: () => P;
    };
    /** promise重试 */
    static retry: <P extends Promise<any>>(createPromise: () => P, { maxRetry: maxRetryInit, getDelay, }: {
        maxRetry: number;
        getDelay?: ((retryCount: number) => number) | undefined;
    }) => Promise<P>;
    readonly [Symbol.toStringTag]: string;
    constructor(executorRaw: XPromiseExecutor<T>);
    then<TResult1 = T, TResult2 = never>(onFulfilled?: (value: T) => TResult1 | PromiseLike<TResult1>, onRejected?: (reason: any) => TResult2 | PromiseLike<TResult2>): XPromise<TResult1 | TResult2>;
    catch<TResult = never>(onRejected?: (reason: any) => TResult | PromiseLike<TResult>): XPromise<T | TResult>;
    finally(onFinally?: () => void): XPromise<T>;
    /** 超时设置 */
    timeout: (time: number) => XPromise<T>;
    /** 中止promise */
    abort: (message?: string) => this;
}
