import { XPromiseError } from '../error';

/** promise 重试错误 */
export declare class XPromiseRetryError extends XPromiseError {
    errorList: Error[];
    constructor(errorList: Error[]);
}
/** promise 重试 */
export declare const promiseRetry: <P extends Promise<any>>(createPromise: () => P, { maxRetry: maxRetryInit, getDelay, }: {
    /** 最大重试次数 */
    maxRetry: number;
    /** 延迟时间 */
    getDelay?: ((retryCount: number) => number) | undefined;
}) => Promise<P>;
